/*****************************************************************************
* Copyright (c) Bridgetek Pte Ltd.
* Software License Agreement
*
* This code is provided as an example only and is not guaranteed by Bridgetek. 
* BRIDGETEK accept no responsibility for any issues resulting from its use. 
* The developer of the final application incorporating any parts of this 
* sample project is responsible for ensuring its safe and correct operation 
* and for any consequences resulting from its use.
*****************************************************************************/
/**
* @file  App_RotaryDial
* @brief Sample application to demonstrate EVE primitives and widgets.
Versoin 5.0 - April/17/2017 - Restructure source code
*/

#include "Platform.h"
#include "App_RotaryDial.h"
#include "App_Common.h"

#include "Font_Table.h"
#define DIAL		1

/* Global used for context hal */
Gpu_Hal_Context_t host,*phost;

int32_t BaseTrackVal = 0,BaseTrackValInit = 0,BaseTrackValSign = 0,MemLoc=0;

uint32_t Load_RawDataFromfile(uchar8_t *ImageArrayname,/* Image Array*/
								 uint32_t ptr,/* Array Size*/
								 uint32_t RamAddr,
								 int16_t Handle,
								 int16_t Format,
								 int16_t Stride,
								 int16_t Width,
								 int16_t Height,
								 uint8_t i
								 )
{
#ifdef FT9XX_PLATFORM

	//FIL *pRAWDATAFILE;

#elif defined(MSVC_PLATFORM) || defined(MSVC_FT800EMU) 
	//FILE *pRawDataFile = NULL;
#endif
	uint8_t *pbuff = NULL;
	int32_t FileLen=0,fsize=0;

		/* Make the RAM address align of 8 */
		RamAddr = (uint32_t)(RamAddr + 7) & (~7);

		
		fsize = Uncompressed_FileSize[i];
		
	App_Flush_Co_Buffer(phost);
	Gpu_Hal_WaitCmdfifo_empty(phost);

		Gpu_Hal_WrCmd32(phost,  CMD_INFLATE);
		Gpu_Hal_WrCmd32(phost,  RamAddr);



#if defined(MSVC_PLATFORM) || defined(MSVC_FT800EMU) || defined(FT9XX_PLATFORM)
        Gpu_Hal_WrCmdBuf(phost,ImageArrayname,ptr);
#endif
#ifdef ARDUINO_PLATFORM
		Gpu_Hal_WrCmdBufFromFlash(phost,ImageArrayname,ptr);
#endif
		

		App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(Handle));
		App_WrCoCmd_Buffer(phost,BITMAP_SOURCE(RamAddr));
		App_WrCoCmd_Buffer(phost, BITMAP_LAYOUT(Format,Stride,Height));		
#ifdef DISPLAY_RESOLUTION_WVGA
		App_WrCoCmd_Buffer(phost, BITMAP_LAYOUT_H(Stride>>10,Height>>9));
#endif
		App_WrCoCmd_Buffer(phost, BITMAP_SIZE(NEAREST,BORDER,BORDER,Width,Height));
#ifdef  DISPLAY_RESOLUTION_WVGA
		App_WrCoCmd_Buffer(phost, BITMAP_SIZE_H(Width>>9,Height>>9));
#endif
		App_WrCoCmd_Buffer(phost, VERTEX2II(0,0,Handle,0));				
		
		
	fsize = (fsize + 7) & (~7);//align the buffer to 8
	return (RamAddr + fsize);
}

void Rotary_Dial_phone()
{
	uint8_t ReadTag = 0,PrevTag = 0,StoreTag,flag =0, PrintTag=0,Tagcheck=0,Penup = 0,i=0,j;	

	char8_t StringArray[31];	
	int32_t tmprate = 0;	

	int32_t FontWid = 0, FontHt = 0,temp =0,tagval,PrevTh = 0,adjusting = 0, CurrTh,MemLoc=0,VertexX, VertexY;	
	int16_t OuterCircleRadius=0, InnerCircleRadius, DiffbetRadius,DiffbetRadiusbytwo, CentreWhiteCircle,FontSizeCentre;
	int16_t ScreenWidthMid,ScreenHeightMid,FontPLaceX[10],FontPLaceY[10],SmallNumCircleRad, k=0,l=0 ,m=0,FontSize,StartTheta,EndTheta,IncTheta;
	int16_t NextTh=0,NoTouch,Touch,PrevTouch = 1,NoX,NoY,vX,MinTheta,MaxTheta,threshold_angle=0,thresholdflag=0;
	int16_t ButHt, ButWid,FingerstopX,FingerstopY;
	uint32_t RotaryTag=0;
	
	int16_t th,theta;	
	RotaryDial_Bmps_t BmpBalls[40];//for background animation effects

	ScreenWidthMid = DispWidth/2;
	ScreenHeightMid = DispHeight/2; 

	

	#ifdef DISPLAY_RESOLUTION_WQVGA
	OuterCircleRadius = ScreenWidthMid/2 - 19;	
	InnerCircleRadius = OuterCircleRadius - 50;
	SmallNumCircleRad = InnerCircleRadius/2 - 8;
	FingerstopX = ScreenWidthMid + 56;
	FingerstopY = ScreenHeightMid + 17;
	NoX = DispWidth/6;//80; //(ScreenWidthMid)-(ScreenWidthMid/2);
	NoY = DispHeight - (DispHeight - 7);//7;
	ButHt = ScreenHeightMid - 111;
	ButWid = DispWidth - 160;
	#endif
	#ifdef DISPLAY_RESOLUTION_QVGA
	OuterCircleRadius = ScreenWidthMid/2 + 5;	
	InnerCircleRadius = OuterCircleRadius - 45;
	SmallNumCircleRad = InnerCircleRadius/4 + 3;
	FingerstopX = ScreenWidthMid + 42;
	FingerstopY = ScreenHeightMid +10;
	NoX = DispWidth/6;//80; //(ScreenWidthMid)-(ScreenWidthMid/2);
	NoY = DispHeight - (DispHeight - 7);//7;
	ButHt = ScreenHeightMid - 95;
	ButWid = DispWidth - 110;
	#endif
#ifdef DISPLAY_RESOLUTION_WVGA
	OuterCircleRadius = ScreenWidthMid/2 - 30;
	InnerCircleRadius = OuterCircleRadius - 70;
	SmallNumCircleRad = InnerCircleRadius/2 - 24;
	FingerstopX = ScreenWidthMid + 110;
	FingerstopY = ScreenHeightMid + 37;
	NoX = DispWidth/10;//80; //(ScreenWidthMid)-(ScreenWidthMid/2);
	NoY = DispHeight/60;//7;
	ButHt = ScreenHeightMid - 180;
	ButWid = DispWidth - 200;
#endif
#ifdef DISPLAY_RESOLUTION_HVGA_PORTRAIT
	OuterCircleRadius = ScreenWidthMid/2 +44;
	InnerCircleRadius = OuterCircleRadius-44;
	SmallNumCircleRad = InnerCircleRadius/2 - 20;
	FingerstopX = ScreenWidthMid + 90;
	FingerstopY = ScreenHeightMid + 37;
	printf("\n Out=%d in=%d small=%d stopx=%d stopy=%d",OuterCircleRadius,InnerCircleRadius,SmallNumCircleRad,FingerstopX,FingerstopY);
	NoX = DispWidth/5;//80; //(ScreenWidthMid)-(ScreenWidthMid/2);
	NoY = DispHeight/30;//7;
	ButHt = ScreenHeightMid - 190;
	ButWid = DispWidth - 140;
#endif
	DiffbetRadius = OuterCircleRadius - InnerCircleRadius;
	DiffbetRadiusbytwo = DiffbetRadius/2;
	CentreWhiteCircle = InnerCircleRadius + DiffbetRadiusbytwo;
	
	//DiffbetRadius = 0;
	VertexX = 0;
	VertexY = 0;	

	FontSize = 28;
	FontSizeCentre = 31;

	StartTheta = 45;
	EndTheta = 270+45;
	IncTheta = 30;
	NoTouch = -32768;

	MinTheta = 60;
	MaxTheta = 90;

	vX = ScreenWidthMid;

	StringArray[0] = '\0';
	tagval = 10;
	Gpu_Hal_WrCmd32(phost, CMD_MEMSET);
	Gpu_Hal_WrCmd32(phost, 0L);//starting address of memset
	Gpu_Hal_WrCmd32(phost, 55L);//value of memset
	Gpu_Hal_WrCmd32(phost,256*1024);



	/* assign tracks to the white circles outside the do while loop*/
	for(theta = StartTheta; theta<= EndTheta; theta+=IncTheta)
	{
		
		th = theta;	
		th = 2*da(th,-90);

		temp = 0;
		if(theta  == StartTheta +30) i = 9;			
		j = i+'0';
		FontWid = g_Gpu_Fonts[temp].FontWidth[j];
		FontHt =  g_Gpu_Fonts[temp].FontHeightInPixels	;
		polarxy(CentreWhiteCircle,th,&VertexX,&VertexY,ScreenWidthMid,ScreenHeightMid);
		
		FontPLaceX[l] = (VertexX/16) - (FontWid/2);
		FontPLaceY[l] = (VertexY/16) - (FontHt/2);
					
		i--;
		l++;
			
	}

	/* set the vol to max */
	Gpu_Hal_Wr8(phost, REG_VOL_SOUND,0xFF);

	/* Calculation of balls offsets and rate */
	for(i=0;i<40;i++)
	{
		BmpBalls[i].xOffset = random(DispWidth);
		BmpBalls[i].yOffset = random(DispHeight);

		BmpBalls[i].xDiff = random(16) - 8;
		BmpBalls[i].yDiff = random(8) - 4;
	}
	
	/* Construction of starting screen shot, assign all the bitmap handles here */
	App_WrCoCmd_Buffer(phost, CMD_DLSTART);
	App_WrCoCmd_Buffer(phost,CLEAR_COLOR_RGB(255,255,255));
	App_WrCoCmd_Buffer(phost,CLEAR(1,1,1));
	
	/* track circles outside the while loop */
	for(theta=StartTheta;theta<=EndTheta ;theta+=IncTheta)			
	{	
		th = theta;		
		if(theta == StartTheta + IncTheta) tagval = 9;
		th = 2*da(th,-90);				
		Gpu_CoCmd_Track(phost,ScreenWidthMid, ScreenHeightMid, DIAL, DIAL, tagval);		
		tagval--;
	}
	
	/* Download the raw data into intended locations */
	{
		uint32_t RamAddrOffest = RAM_G;
		App_WrCoCmd_Buffer(phost, BEGIN(BITMAPS));
	
		RamAddrOffest = Load_RawDataFromfile((uchar8_t*)FingerStop,FingerStop_SIZE,RamAddrOffest,0,ARGB4,56*2,56,38,0);//finger stopper
		RamAddrOffest = Load_RawDataFromfile((uchar8_t*)Call,CallIcon,RamAddrOffest,1,ARGB4,56*2,56,56,1);//reject button
		RamAddrOffest = Load_RawDataFromfile((uchar8_t*)CallCancel,CallCancelIcon,RamAddrOffest,2,ARGB4,56*2,56,56,2);//call button
		RamAddrOffest = Load_RawDataFromfile((uchar8_t*)YellowBall20x20,YellowBall_20x20,RamAddrOffest,3,ARGB4,20*2,20,20,3);//ball 20x20
		RamAddrOffest = Load_RawDataFromfile((uchar8_t*)YellowBall30x30,YellowBall_30x30,RamAddrOffest,4,ARGB4,30*2,30,30,4);//ball 30x30
		RamAddrOffest = Load_RawDataFromfile((uchar8_t*)YellowBall40x40,YellowBall_40x40,RamAddrOffest,5,ARGB4,40*2,40,40,5);//ball 40x40
		RamAddrOffest = Load_RawDataFromfile((uint8_t*)YellowBall60x60,YellowBall_60x60,RamAddrOffest,6,ARGB4,60*2,60,60,6);//ball 60x60

		App_WrCoCmd_Buffer(phost, END());
	}

	App_WrCoCmd_Buffer(phost,DISPLAY());
	Gpu_CoCmd_Swap(phost);

	/* Download the commands into fifo */
	App_Flush_Co_Buffer(phost);

	/* Wait till coprocessor completes the operation */
	Gpu_Hal_WaitCmdfifo_empty(phost);



	do{
		
		App_WrCoCmd_Buffer(phost, CMD_DLSTART);

		/*Points*/
		App_WrCoCmd_Buffer(phost, CLEAR_COLOR_RGB(237 ,186 ,17) ); // background color
		App_WrCoCmd_Buffer(phost,CLEAR(1,1,1));
		/* Draw two gradients, one at the top and another at the bottom. Height of former is 
                   80% of display height and later 20% of display height */
		App_WrCoCmd_Buffer(phost,SCISSOR_SIZE(DispWidth,4*DispHeight/5));
		App_WrCoCmd_Buffer(phost,SCISSOR_XY(0,0));
		Gpu_CoCmd_Gradient(phost,0, 0, 0xEDBA11,0, DispHeight, 0x82660A);
		App_WrCoCmd_Buffer(phost,SCISSOR_SIZE(DispWidth,DispHeight));
		App_WrCoCmd_Buffer(phost,SCISSOR_XY(0,4*DispHeight/5));
		Gpu_CoCmd_Gradient(phost,0, 0, 0x2B2205,0, ((DispHeight*0.80))/*218*/, 0x82660A);
		App_WrCoCmd_Buffer(phost,SCISSOR_SIZE(DispWidth,DispHeight));
		App_WrCoCmd_Buffer(phost,SCISSOR_XY(0,0));
		

		/* Draw all the background bitmaps - balls with various resolutions */
		App_WrCoCmd_Buffer(phost,BEGIN(BITMAPS));
		App_WrCoCmd_Buffer(phost,COLOR_RGB(255 ,255 ,255)); // brown outside circle
		for(i = 0;i<40;i++)
		{
#ifdef DISPLAY_RESOLUTION_WVGA
			App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(3+(i%4)));
			App_WrCoCmd_Buffer(phost,CELL(0));
			App_WrCoCmd_Buffer(phost,VERTEX2F(BmpBalls[i].xOffset*16,BmpBalls[i].yOffset*16));
#else
			App_WrCoCmd_Buffer(phost,VERTEX2II(BmpBalls[i].xOffset,BmpBalls[i].yOffset,3+(i%4),0));
#endif
			BmpBalls[i].xOffset += BmpBalls[i].xDiff;
			BmpBalls[i].yOffset += BmpBalls[i].yDiff;

			if(BmpBalls[i].xOffset < -80)
			{
				BmpBalls[i].xOffset = DispWidth + 80;
			}
			else if(BmpBalls[i].xOffset > DispWidth + 80)
			{
				BmpBalls[i].xOffset = -80;
			}

			if(BmpBalls[i].yOffset < -80)
			{
				BmpBalls[i].yOffset = DispHeight + 80;
			}
			else if(BmpBalls[i].yOffset > DispHeight + 80)
			{
				BmpBalls[i].yOffset = -80;
			}
		}

		BmpBalls[random(40)].xDiff = random(16) - 6;
		BmpBalls[random(40)].yDiff = random(8) - 4;
		
		//		BmpBalls[random(40)].xDiff = random(16) ;
		//BmpBalls[random(40)].yDiff = random(8) ;

		App_WrCoCmd_Buffer(phost,POINT_SIZE(OuterCircleRadius * 16) );
		
		App_WrCoCmd_Buffer(phost,BEGIN(FTPOINTS));
		App_WrCoCmd_Buffer(phost,COLOR_RGB(235 ,117 ,0)); // brown outside circle
		App_WrCoCmd_Buffer(phost,VERTEX2F(ScreenWidthMid*16 - 24,ScreenHeightMid*16 - 24));
		App_WrCoCmd_Buffer(phost,COLOR_RGB(0 ,0 ,0)); // brown outside circle
		App_WrCoCmd_Buffer(phost,VERTEX2F(ScreenWidthMid*16 + 24,ScreenHeightMid*16 + 24));
		App_WrCoCmd_Buffer(phost,COLOR_RGB(128 ,64 ,0)); // brown outside circle
		App_WrCoCmd_Buffer(phost,VERTEX2F(ScreenWidthMid*16,ScreenHeightMid*16));
		

	
		App_WrCoCmd_Buffer(phost,POINT_SIZE((InnerCircleRadius) * 16) );
		App_WrCoCmd_Buffer(phost,COLOR_RGB(87 ,64 ,8)); // inner circle - light brown color
		App_WrCoCmd_Buffer(phost,VERTEX2F(ScreenWidthMid*16 - 24,ScreenHeightMid*16 - 24));
		App_WrCoCmd_Buffer(phost,COLOR_RGB(0 ,0 ,0)); // inner circle - light brown color
		App_WrCoCmd_Buffer(phost,VERTEX2F(ScreenWidthMid*16 + 24,ScreenHeightMid*16+24));
		App_WrCoCmd_Buffer(phost,COLOR_RGB(204 ,151 ,16)); // inner circle - light brown color
		App_WrCoCmd_Buffer(phost,VERTEX2F(ScreenWidthMid*16,ScreenHeightMid*16));
	

		i = 0;//font inside the white circles - start at 0
		tagval = 10;// tag for the white circles - decrementing tagvalue inside loop
		

		NoTouch = -32768;

		CurrTh = 0;
		threshold_angle = 320;
	
		Touch = Gpu_Hal_Rd16(phost, REG_TOUCH_SCREEN_XY+2);
		Tagcheck = Gpu_Hal_Rd8(phost, REG_TOUCH_TAG);

        RotaryTag = Gpu_Hal_Rd32(phost,REG_TRACKER);
		StoreTag = RotaryTag & 0xff;
		ReadTag = StoreTag;
	
		if((PrevTouch&0x8000) && (0 == PrevTag))
		{
			BaseTrackValInit = (int16_t)((RotaryTag >> 16) & 0xffff);
		}
		else
		{
			BaseTrackValInit = 0;
		}
        /* verify for the track value */
        if((Touch != NoTouch))
		{
			if((StoreTag >= 1) && (StoreTag <= 10))
			{
				CurrTh = (int16_t)((RotaryTag >> 16) & 0xffff);
				  /* BaseTrackVal is the rotary track value of the particular white circle that is moving */
				if(adjusting!=0)
				{
					flag = 0;
					BaseTrackVal += (int16_t)(CurrTh - PrevTh);
					BaseTrackValSign += (int16_t)(CurrTh - PrevTh);
					/* handling of loopback */
					BaseTrackVal &= 0xffff;		
					 /* NextTh value is the track value in degrees */
					NextTh = (uint16_t)(BaseTrackValSign / 182);	
				
				
				} 
				PrevTh = CurrTh;
				adjusting = (RotaryTag & 0xff);
				PrintTag = ReadTag;

			
			}
		}
        else if(Touch == NoTouch)
        {
			BaseTrackVal=0;		
			flag = 1;
			if(adjusting != 0)
			{
				 /* If white circles have moved beyond their initial value, Nextth value is incremented */
				if(NextTh > 0 )
				{
					
                    /* After the white circle has moved to the desired location, and when penup has been done,
                    the white crcles moved back to its original positon of 0 degrees. */
                    /* NextTh moves back in degrees of twenty in steps. Also sound has to be played when moving back. */
					NextTh-=20;	
					Gpu_Hal_Wr8(phost, REG_VOL_SOUND,0xff);
					Gpu_Hal_Wr16(phost, REG_SOUND,0x51);
					Gpu_Hal_Wr8(phost, REG_PLAY,1);
					MinTheta = 60;
					MaxTheta = 90;
					
				}
				else
				{ 
					/* When the white circles have moved back to its original position, the tag value of the particular white circle 
                    (PrintTag) is stored in the StringArray. StringArray stores upto 17 values. The thresholdflag is also checked 
                    before entering this loop */
					NextTh = 0;
					if((PrintTag >= 1) && (PrintTag <= 10) && (thresholdflag ==1))
					{
						if (PrintTag == 10)PrintTag = 0;
						StringArray[k] = PrintTag + '0';
						
						if(k<17)
						{
							k++;							
						}
						else if (k == 17)
						{
							k = 0;
							StringArray[k] = PrintTag + '0';
							k++;
						}
						thresholdflag=0;
					}
					StringArray[k] = '\0';					
					adjusting = 0;
				//	_sleep(1);
				}					
			}
			 /* When movement has been finished, the RotaryTag and Printtag are cleared*/
			else if(adjusting == 0)
			{
				RotaryTag = '\0';
				PrintTag = '\0';			
				
			}
			BaseTrackValSign = 0;
		}
		 /* Sound play wrt user touch */
         /* When white circles are touched for the first time after penup - play sound */
		if((PrevTag == 0)&& ((ReadTag !=0)&&(ReadTag !=255)) && ( Penup = 1))
        {
			  Gpu_Hal_Wr8(phost, REG_VOL_SOUND,0xFF);
		      Gpu_Hal_Wr16(phost, REG_SOUND,0x51);
		      Gpu_Hal_Wr8(phost, REG_PLAY,1);
              Penup = 0;
        }
		/* dial button (tag 100) & penup has been done - play dtmf sound */
		if((Tagcheck == 100)  && (flag == 1))
		{
			if(k>0)
			{
				delay(200);
				for(m=0;m<k;m++)
				{
					/* Play the dtmf sound */
					Gpu_Hal_Wr16(phost, REG_SOUND,StringArray[m]);
					Gpu_Hal_Wr8(phost, REG_PLAY,1);
					delay(80);
					Gpu_Hal_Wr16(phost, REG_SOUND,0);
					Gpu_Hal_Wr8(phost, REG_PLAY,1);
					delay(80);
				}
			}

		}

		/* reject button (tag -200)& penup has been done. clear the string */
		if((Tagcheck == 200) && (flag ==1) )
		{
			for(m =0;m<=k;m++)
			{
				StringArray[m] = '\0';
			}
			k=0;

		}


		App_WrCoCmd_Buffer(phost,BEGIN(FTPOINTS));
		App_WrCoCmd_Buffer(phost,STENCIL_OP(INCR,INCR));//pass or fail increment	
		App_WrCoCmd_Buffer(phost,POINT_SIZE(SmallNumCircleRad * 16) );
		App_WrCoCmd_Buffer(phost,COLOR_A(255));
		App_WrCoCmd_Buffer(phost,COLOR_RGB(255 ,255 ,255));	
	
		App_WrCoCmd_Buffer(phost,TAG_MASK(1));
		/* Placement of number circles which will move around the rotary */		
		for(theta=StartTheta;theta<=EndTheta ;theta+=IncTheta)			
		{	
			
			th = theta;		
			if(theta == StartTheta + IncTheta) tagval = 9;	
			
			/* limit threshold level near finger stop*/
			/* for value 0 - tag is 10*/
			if((NextTh > threshold_angle) && (ReadTag == 10))
			{
				NextTh = threshold_angle;
				thresholdflag =1;
			}
			
			/* for value 1 to 9 - threshold*/
			for(m = 1,l=9; m<=9, l>=1;m++,l--)
			{
				if((NextTh > threshold_angle - (m*IncTheta)) && (ReadTag == l))
				{
					NextTh = threshold_angle - (m*IncTheta);
					thresholdflag =1;
				}
			}
			/* Stop anticlockwise movement of the dial*/					
			if((BaseTrackValInit + BaseTrackValSign) < BaseTrackValInit)
			{
				NextTh = 0;
			}
			th = th + NextTh;		
			/* calculation of th value in pixels with input in degrees */
			th = 2*da(th,-90);	

			/* calculate x and  y for placing circles according to degree */
			polarxy(CentreWhiteCircle,th,&VertexX ,&VertexY ,ScreenWidthMid,ScreenHeightMid);	
			
		
			App_WrCoCmd_Buffer(phost,TAG(tagval));
			App_WrCoCmd_Buffer(phost,COLOR_RGB(200 ,99 ,0)); // for 3d effect adding circles of darker color
			App_WrCoCmd_Buffer(phost,VERTEX2F(VertexX-24,VertexY-24));
			App_WrCoCmd_Buffer(phost,COLOR_RGB(0 ,0 ,0)); 
			App_WrCoCmd_Buffer(phost,VERTEX2F(VertexX+24,VertexY+24));// for 3d effect adding circles of darker color
			App_WrCoCmd_Buffer(phost,COLOR_RGB(255 ,255 ,255));	
			App_WrCoCmd_Buffer(phost,VERTEX2F(VertexX,VertexY));// the base number circle
			
			tagval--;	
			
		}
		App_WrCoCmd_Buffer(phost,TAG_MASK(0));			
		
		/* Play Sound when Nexth(base track value crosses bands within range 30 */
		if((NextTh > MaxTheta) &&(NextTh!=0)&& (Touch != NoTouch))
		{
			Gpu_Hal_Wr8(phost, REG_VOL_SOUND,0xFF);
			Gpu_Hal_Wr16(phost, REG_SOUND,0x51);
			Gpu_Hal_Wr8(phost, REG_PLAY,1);
			MinTheta = MinTheta + IncTheta;
			MaxTheta = MaxTheta + IncTheta;		
		}
		else if(((NextTh < MinTheta) && (NextTh >(MinTheta-30))) && (NextTh!=0)&&(Touch != NoTouch))
		{
			Gpu_Hal_Wr8(phost, REG_VOL_SOUND,0xFF);
			Gpu_Hal_Wr16(phost, REG_SOUND,0x51);
			Gpu_Hal_Wr8(phost, REG_PLAY,1);
			MinTheta = MinTheta - IncTheta;
			MaxTheta = MaxTheta - IncTheta;		
		}
			
		
		/* Placement of NUmbers inside the white circle - using stencil effect*/
		
		App_WrCoCmd_Buffer(phost,STENCIL_FUNC(GEQUAL,1,255));
		App_WrCoCmd_Buffer(phost,COLOR_RGB(0 ,0 ,0));
		App_WrCoCmd_Buffer(phost,BEGIN(BITMAPS));

			i =0;
			for(l =0; l<=9; l++)
			{
				if(l==1)
				{
					i=9;
				}
#ifdef DISPLAY_RESOLUTION_WVGA
				App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(FontSize));
				App_WrCoCmd_Buffer(phost,CELL(i+'0'));
				App_WrCoCmd_Buffer(phost,VERTEX2F(FontPLaceX[l]*16,FontPLaceY[l]*16));
#else
				App_WrCoCmd_Buffer(phost,VERTEX2II(FontPLaceX[l],FontPLaceY[l],FontSize,i+'0'));				
#endif
				i--;
			}
		

		App_WrCoCmd_Buffer(phost,STENCIL_OP(KEEP,KEEP));
        App_WrCoCmd_Buffer(phost,STENCIL_FUNC(ALWAYS,0,255));
        App_WrCoCmd_Buffer(phost,COLOR_A(128));

		i =0;
		for(l =0; l<=9; l++)
		{
			if(l==1)
				{
					i=9;
				}
#ifdef DISPLAY_RESOLUTION_WVGA
				App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(FontSize));
				App_WrCoCmd_Buffer(phost,CELL(i+'0'));
				App_WrCoCmd_Buffer(phost,VERTEX2F(FontPLaceX[l]*16,FontPLaceY[l]*16));
#else
				App_WrCoCmd_Buffer(phost,VERTEX2II(FontPLaceX[l],FontPLaceY[l],FontSize,i+'0'));
#endif
				i--;
		}
		
		App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
		App_WrCoCmd_Buffer(phost,COLOR_A(255));
		App_WrCoCmd_Buffer(phost,BEGIN(BITMAPS));		

		/* dial image Placement*/
		App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
		App_WrCoCmd_Buffer(phost,TAG_MASK(1));
		App_WrCoCmd_Buffer(phost,TAG(100));
#ifdef  DISPLAY_RESOLUTION_WVGA
		App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(2));
		App_WrCoCmd_Buffer(phost,CELL(0));
		App_WrCoCmd_Buffer(phost,VERTEX2F((ScreenWidthMid-131)*16,(DispHeight-70)*16));

#else
		App_WrCoCmd_Buffer(phost,VERTEX2II(ScreenWidthMid-131,DispHeight-70,2,0));
#endif
		App_WrCoCmd_Buffer(phost,TAG_MASK(0));		
		
		/* display numbers in the centre of the point while dialing*/
		if((PrintTag >0 ) && (PrintTag <= 10) && (Touch != NoTouch))
		{
		
			if (PrintTag == 10)PrintTag = 0;
			App_WrCoCmd_Buffer(phost,COLOR_RGB(0,0,0));
			Gpu_CoCmd_Number(phost,(ScreenWidthMid - 16)/*225*/,(ScreenHeightMid - 27)/*110*/,FontSizeCentre,0,PrintTag);
			App_WrCoCmd_Buffer(phost,COLOR_RGB(0,0,0));
			Gpu_CoCmd_Number(phost,(ScreenWidthMid - 14)/*225*/,(ScreenHeightMid - 25)/*110*/,FontSizeCentre,0,PrintTag);
			App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
			Gpu_CoCmd_Number(phost,(ScreenWidthMid - 15)/*225*/,(ScreenHeightMid - 26)/*110*/,FontSizeCentre,0,PrintTag);
			if (PrintTag == 0)PrintTag = 10;
		}
		/* fingerstop image placement */		
		App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
#ifdef  DISPLAY_RESOLUTION_WVGA
		App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(0));
		App_WrCoCmd_Buffer(phost,CELL(0));
		App_WrCoCmd_Buffer(phost,VERTEX2F((FingerstopX)*16,(FingerstopY)*16));

#else
		App_WrCoCmd_Buffer(phost,VERTEX2II(FingerstopX/*296*/,FingerstopY/*153*/,0,0)); //exact location of picture		
#endif
		/*reject image placement*/
		App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
		App_WrCoCmd_Buffer(phost,TAG_MASK(1));
		App_WrCoCmd_Buffer(phost,TAG(200));
#ifdef  DISPLAY_RESOLUTION_WVGA
		App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(1));
		App_WrCoCmd_Buffer(phost,CELL(0));
		App_WrCoCmd_Buffer(phost,VERTEX2F((ScreenWidthMid+80)*16,(DispHeight-70)*16));
#else
		App_WrCoCmd_Buffer(phost,VERTEX2II(ScreenWidthMid+80,DispHeight-70,1,0));
#endif
		App_WrCoCmd_Buffer(phost,TAG_MASK(0));


		Gpu_CoCmd_FgColor(phost, 0xCC9710); // color of number display button
		Gpu_CoCmd_Button(phost, NoX, NoY -2/*5*/, ButWid, ButHt, FontSize, 0, "");// placement of button

		App_WrCoCmd_Buffer(phost,COLOR_RGB(0,0,0));//color of number(text) color
	
		Gpu_CoCmd_Text(phost,(NoX + ButWid/2),(NoY + ButHt/2),FontSize,OPT_CENTER,StringArray);
		App_WrCoCmd_Buffer(phost, END());

		App_WrCoCmd_Buffer(phost,DISPLAY());

		Gpu_CoCmd_Swap(phost);

		/* Download the commands into fifo */
		App_Flush_Co_Buffer(phost);

		/* Wait till coprocessor completes the operation */
		Gpu_Hal_WaitCmdfifo_empty(phost);
		PrevTag = ReadTag;
		PrevTouch = Touch;
		tmprate++;
		}while(1);
			

}


/* Startup Screen Information*/ 

#if defined(ARDUINO_PLATFORM)
prog_char8_t * const info[] =
#else
char *info[] =
#endif 
{  "EVE Rotary Dial Application",
    "APP to demonstrate interactive rotary dial,",
    "using Points, Track",
    "& Stencil"
}; 

/* Boot up for FT800 followed by graphics primitive sample cases */
/* Initial boot up DL - make the back ground green color */

#if defined MSVC_PLATFORM | defined FT9XX_PLATFORM
/* Main entry point */
int32_t main(int32_t argc,char8_t *argv[])
#endif
#if defined(ARDUINO_PLATFORM) || defined(MSVC_FT800EMU)
void setup()
#endif
{

    phost = &host;
    /* Init HW Hal */
    App_Common_Init(phost);
    /* Show Logo, do calibration and display welcome screeen */
    App_Common_Start(phost,info);
    /* Main application */
    Rotary_Dial_phone();   

    /* Close all the opened handles */
    App_Common_Close(phost);	

#ifdef MSVC_PLATFORM
	return 0;
#endif
}

void loop()
{
}



/* Nothing beyond this */
